<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:fx="#fx-functions" exclude-result-prefixes="msxsl fx">
	<xsl:output method="html" version="4.0" indent="yes" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"/>
	<xsl:key name="GroupLevel0" match="qryRptDepartmentsEmp" use="string(Department)" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"/>
	<xsl:template match="//dataroot" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
		<html>
			<head>
				<META HTTP-EQUIV="Content-Type" CONTENT="text/html;charset=UTF-8"/>
				<title>rptDepartments</title>
				<style type="text/css">
		.Style0 { BORDER-STYLE: none; COLOR: #800000; BACKGROUND-COLOR: #ffffff; BORDER-WIDTH: 1px; BORDER-COLOR: #000000; TEXT-ALIGN: left; WRITING-MODE: lr-tb; VISIBILITY: visible; FONT-WEIGHT: 900; FONT-SIZE: 20pt; FONT-FAMILY: Times New Roman; FONT-STYLE: normal; TEXT-DECORATION: none; PADDING-TOP: 0.in; PADDING-BOTTOM: 0.in; PADDING-RIGHT: 0.in; PADDING-LEFT: 0.in }
	
		.Style1 { BORDER-STYLE: none; COLOR: #000000; BACKGROUND-COLOR: transparent; BORDER-WIDTH: 1px; BORDER-COLOR: #000000; TEXT-ALIGN: left; WRITING-MODE: lr-tb; VISIBILITY: visible; FONT-WEIGHT: 900; FONT-SIZE: 10pt; FONT-FAMILY: Arial; FONT-STYLE: normal; TEXT-DECORATION: none; PADDING-TOP: 0.in; PADDING-BOTTOM: 0.in; PADDING-RIGHT: 0.in; PADDING-LEFT: 0.in }
	
		.Style2 { BORDER-STYLE: none; COLOR: #000000; BACKGROUND-COLOR: transparent; BORDER-WIDTH: 1px; BORDER-COLOR: #000000; TEXT-ALIGN: right; WRITING-MODE: lr-tb; VISIBILITY: visible; FONT-WEIGHT: 900; FONT-SIZE: 10pt; FONT-FAMILY: Arial; FONT-STYLE: normal; TEXT-DECORATION: none; PADDING-TOP: 0.in; PADDING-BOTTOM: 0.in; PADDING-RIGHT: 0.in; PADDING-LEFT: 0.in }
	
		.Style3 { BORDER-STYLE: solid; BORDER-WIDTH: 2pt; BORDER-COLOR: #800000; VISIBILITY: visible }
	
		.Style4 { BORDER-STYLE: none; COLOR: #000000; BACKGROUND-COLOR: transparent; BORDER-WIDTH: 1px; BORDER-COLOR: #000000; TEXT-ALIGN: general; WRITING-MODE: lr-tb; VISIBILITY: visible; FONT-WEIGHT: 400; FONT-SIZE: 9pt; FONT-FAMILY: Times New Roman; FONT-STYLE: normal; TEXT-DECORATION: none; PADDING-TOP: 0.in; PADDING-BOTTOM: 0.in; PADDING-RIGHT: 0.in; PADDING-LEFT: 0.in }
	
		.Style5 { BORDER-STYLE: solid; BORDER-WIDTH: 1pt; BORDER-COLOR: #800000; VISIBILITY: visible }
	
		.Style6 { BORDER-STYLE: none; COLOR: #800000; BACKGROUND-COLOR: transparent; BORDER-WIDTH: 1px; BORDER-COLOR: #000000; TEXT-ALIGN: left; WRITING-MODE: lr-tb; VISIBILITY: visible; FONT-WEIGHT: 700; FONT-SIZE: 14pt; FONT-FAMILY: Times New Roman; FONT-STYLE: italic; TEXT-DECORATION: none; PADDING-TOP: 0.in; PADDING-BOTTOM: 0.in; PADDING-RIGHT: 0.in; PADDING-LEFT: 0.in }
	
		.Style7 { BORDER-STYLE: solid; BORDER-WIDTH: 1px; BORDER-COLOR: #000000; VISIBILITY: visible }
	
		.Style8 { BORDER-STYLE: none; COLOR: #000000; BACKGROUND-COLOR: transparent; BORDER-WIDTH: 1px; BORDER-COLOR: #000000; TEXT-ALIGN: left; WRITING-MODE: lr-tb; VISIBILITY: visible; FONT-WEIGHT: 700; FONT-SIZE: 10pt; FONT-FAMILY: Times New Roman; FONT-STYLE: normal; TEXT-DECORATION: none; PADDING-TOP: 0.in; PADDING-BOTTOM: 0.in; PADDING-RIGHT: 0.in; PADDING-LEFT: 0.in }
	
		.Style9 { BORDER-STYLE: none; COLOR: #000000; BACKGROUND-COLOR: transparent; BORDER-WIDTH: 1px; BORDER-COLOR: #000000; TEXT-ALIGN: right; WRITING-MODE: lr-tb; VISIBILITY: visible; FONT-WEIGHT: 700; FONT-SIZE: 10pt; FONT-FAMILY: Times New Roman; FONT-STYLE: normal; TEXT-DECORATION: none; PADDING-TOP: 0.in; PADDING-BOTTOM: 0.in; PADDING-RIGHT: 0.in; PADDING-LEFT: 0.in }
	
		.Style10 { BORDER-STYLE: solid; BORDER-WIDTH: 3pt; BORDER-COLOR: #000000; VISIBILITY: visible }
	</style>
			</head>
			<body link="#0c0000" vlink="#050000">
				<xsl:variable name="GlobalGroup" select="qryRptDepartmentsEmp"/>
				<!-- Calculate expressions and running sums -->
				<xsl:value-of select="fx:CalculateExpressions_Global($GlobalGroup[1], $GlobalGroup)"/>
				<div style="BORDER-STYLE: none; WIDTH: 7.4791in; BACKGROUND-COLOR: #ffffff; VISIBILITY: visible; HEIGHT: 0.in; POSITION: relative"></div>
				<div style="BORDER-STYLE: none; WIDTH: 7.4791in; BACKGROUND-COLOR: #ffffff; VISIBILITY: visible; HEIGHT: 0.4687in; POSITION: relative">
					<span class="Style0" style="LEFT: 0.0729in; TOP: 0.0729in; WIDTH: 1.9583in; HEIGHT: 0.3541in; OVERFLOW: hidden; POSITION: absolute">Departments</span>
				</div>
				<xsl:for-each select="qryRptDepartmentsEmp[count(. | key('GroupLevel0', string(Department))[1]) = 1]">
					<xsl:sort select="Department" order="ascending" data-type="text"/>
					<!-- Calculate expressions and running sums -->
					<xsl:value-of select="fx:CalculateExpressions_0(., key('GroupLevel0', string(Department)))"/>
					<div style="BORDER-STYLE: none; WIDTH: 7.4791in; BACKGROUND-COLOR: #ffffff; VISIBILITY: visible; HEIGHT: 1.2916in; POSITION: relative">
						<span class="Style1" style="LEFT: 0.4972in; TOP: 0.0416in; WIDTH: 1.25in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">Department</span>
						<span class="Style2" style="LEFT: 0.0833in; TOP: 0.0416in; WIDTH: 0.3645in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">ID</span>
						<span class="Style1" style="LEFT: 1.7965in; TOP: 0.0416in; WIDTH: 1.25in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">Manager</span>
						<span class="Style1" style="LEFT: 3.0958in; TOP: 0.0416in; WIDTH: 1.5in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">Location</span>
						<span class="Style1" style="LEFT: 4.6458in; TOP: 0.0416in; WIDTH: 1.875in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">Address</span>
						<hr id="Line15" class="Style3" style="LEFT: 0.0416in; TOP: 0.2395in; WIDTH: 7.4166in; HEIGHT: 0.in; POSITION: absolute"/>
						<hr id="Line18" class="Style3" style="LEFT: 0.0416in; TOP: 0.in; WIDTH: 7.4166in; HEIGHT: 0.in; POSITION: absolute"/>
						<span class="Style4" style="LEFT: 0.4972in; TOP: 0.2812in; WIDTH: 1.25in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
							<xsl:value-of select="Department"/>
						</span>
						<span class="Style4" style="TEXT-ALIGN: right; LEFT: 0.0833in; TOP: 0.2812in; WIDTH: 0.3645in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
							<xsl:value-of select="DepartmentID"/>
						</span>
						<span class="Style4" style="LEFT: 1.7965in; TOP: 0.2812in; WIDTH: 1.25in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
							<xsl:value-of select="Manager"/>
						</span>
						<span class="Style4" style="LEFT: 3.0958in; TOP: 0.2812in; WIDTH: 1.5in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
							<xsl:value-of select="DeptLocation"/>
						</span>
						<span class="Style4" style="LEFT: 4.6458in; TOP: 0.2812in; WIDTH: 1.875in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
							<xsl:value-of select="DeptAddress"/>
						</span>
						<span class="Style4" style="LEFT: 4.6465in; TOP: 0.4895in; WIDTH: 1.875in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
							<xsl:value-of select="CSPPD"/>
						</span>
						<span class="Style1" style="LEFT: 0.3437in; TOP: 1.0625in; WIDTH: 0.9791in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">Name</span>
						<span class="Style2" style="LEFT: 0.in; TOP: 1.0625in; WIDTH: 0.302in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">No.</span>
						<span class="Style1" style="LEFT: 1.3645in; TOP: 1.0625in; WIDTH: 1.2812in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">Email</span>
						<span class="Style1" style="LEFT: 2.677in; TOP: 1.0625in; WIDTH: 0.5729in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">Admin?</span>
						<span class="Style1" style="LEFT: 3.2812in; TOP: 1.0625in; WIDTH: 1.4166in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">Address</span>
						<span class="Style1" style="LEFT: 4.7291in; TOP: 1.0625in; WIDTH: 0.9062in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">Home Phone</span>
						<span class="Style1" style="LEFT: 5.6666in; TOP: 1.0625in; WIDTH: 0.9062in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">Work Phone</span>
						<span class="Style2" style="LEFT: 6.6041in; TOP: 1.0625in; WIDTH: 0.8125in; HEIGHT: 0.1979in; OVERFLOW: hidden; POSITION: absolute">Birth Date</span>
						<hr id="Line23" class="Style5" style="LEFT: 0.in; TOP: 1.2604in; WIDTH: 7.4166in; HEIGHT: 0.in; POSITION: absolute"/>
						<span class="Style6" style="LEFT: 0.0312in; TOP: 0.7708in; WIDTH: 0.9166in; HEIGHT: 0.2604in; OVERFLOW: hidden; POSITION: absolute">Employees</span>
						<hr id="Line29" class="Style5" style="LEFT: 0.in; TOP: 0.7395in; WIDTH: 7.4159in; HEIGHT: 0.in; POSITION: absolute"/>
					</div>
					<xsl:for-each select="key('GroupLevel0', string(Department))"><xsl:sort select="Department" order="ascending" data-type="text"/>
						<!-- Calculate expressions and running sums -->
						<xsl:value-of select="fx:CalculateExpressions_Detail(., $GlobalGroup)"/>
						<div style="BORDER-STYLE: none; WIDTH: 7.4791in; BACKGROUND-COLOR: #ffffff; VISIBILITY: visible; HEIGHT: 0.4479in; POSITION: relative">
							<span class="Style4" style="LEFT: 0.3437in; TOP: 0.in; WIDTH: 0.9791in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
								<xsl:value-of select="EmpName"/>
							</span>
							<span class="Style4" style="TEXT-ALIGN: right; LEFT: 0.in; TOP: 0.in; WIDTH: 0.302in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
								<xsl:value-of select="EmployeeNumber"/>
							</span>
							<input type="checkbox" style="LEFT: 2.8541in; TOP: 0.0208in; HEIGHT: 0.1666in; POSITION: absolute">
								<xsl:if test="fx:GetValue('IsAdmin', 11)">
									<xsl:attribute name="checked"/>
								</xsl:if>
							</input>
							<span class="Style4" style="LEFT: 3.2812in; TOP: 0.in; WIDTH: 1.4166in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
								<xsl:value-of select="Address"/>
							</span>
							<span class="Style4" style="LEFT: 3.2812in; TOP: 0.2083in; WIDTH: 1.4166in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
								<xsl:value-of select="CSPP"/>
							</span>
							<span class="Style4" style="LEFT: 4.7291in; TOP: 0.in; WIDTH: 0.9062in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
								<xsl:value-of select="HomePhone"/>
							</span>
							<span class="Style4" style="LEFT: 5.6666in; TOP: 0.in; WIDTH: 0.9062in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
								<xsl:value-of select="WorkPhone"/>
							</span>
							<span class="Style4" style="TEXT-ALIGN: right; LEFT: 6.6041in; TOP: 0.in; WIDTH: 0.8125in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
								<xsl:value-of select="fx:FormatFromXSL('BirthDate', '', '', '', 7)"/>
							</span>
							<span class="Style4" style="LEFT: 1.3645in; TOP: 0.in; WIDTH: 1.2812in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
								<xsl:value-of select="Email"/>
							</span>
						</div>
					</xsl:for-each>
					<!-- Prepare for any expressions in the group footer -->
					<xsl:value-of select="fx:PrepExpressions(., key('GroupLevel0', string(Department)))"/></xsl:for-each><!-- Prepare for any expressions in the report or page footer -->
				<xsl:value-of select="fx:PrepExpressions($GlobalGroup[1], $GlobalGroup)"/>
				<div style="BORDER-STYLE: none; WIDTH: 7.4791in; BACKGROUND-COLOR: #ffffff; VISIBILITY: visible; HEIGHT: 0.in; POSITION: relative"></div>
				<div style="BORDER-STYLE: none; WIDTH: 7.4791in; BACKGROUND-COLOR: #ffffff; VISIBILITY: visible; HEIGHT: 0.375in; POSITION: relative">
					<span class="Style8" style="LEFT: 0.0416in; TOP: 0.1666in; WIDTH: 3.5in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
						<xsl:value-of select="fx:ExprFromXSL_1()"/>
					</span>
					<span class="Style9" style="LEFT: 3.9583in; TOP: 0.1666in; WIDTH: 3.5in; HEIGHT: 0.2083in; OVERFLOW: hidden; POSITION: absolute">
						<xsl:value-of select="fx:ExprFromXSL_2()"/>
					</span>
					<hr id="Line16" class="Style10" style="LEFT: 0.0416in; TOP: 0.1666in; WIDTH: 7.4166in; HEIGHT: 0.in; POSITION: absolute"/>
				</div>
			</body>
		</html>
	</xsl:template>
	<msxsl:script language="VBScript" implements-prefix="fx" xmlns:msxsl="urn:schemas-microsoft-com:xslt"><![CDATA[							
	Option Explicit
	
	' ********************************************************************************** 
	' **  Functions dynamically generated to evaluate expressions used as a Control Source   
	' ********************************************************************************** 
	

	' [Text13] = Now()
	' Format: "Long Date"
	' Decimal Places: "auto"
	' Running Sum: "no"
	Dim gExpr_1
	Function ExprFromXSL_1()
		ExprFromXSL_1 = ToString(Format(gExpr_1, "Long Date", "", "", 8))
	End Function
	

	' [Text14] = "Page " & [Page] & " of " & [Pages]
	' Format: ""
	' Decimal Places: "auto"
	' Running Sum: "no"
	Dim gExpr_2
	Function ExprFromXSL_2()
		ExprFromXSL_2 = ToString(gExpr_2)
	End Function
	
	
	' ********************************************************************************** 
	' **  Functions dynamically generated to evaluate running sums 
	' ********************************************************************************** 
	
	' This function will reset the sums for the GroupLevel0 section
	Function ResetRunningSums_0()
	
		ResetRunningSums_0 = ""
	End Function
	
		
	' This function will calculate the running sums and expressions for the GroupLevel0 section
	Function CalculateExpressions_0(CurrentNode, GroupNodes)
		PrepExpressions CurrentNode, GroupNodes
		ResetRunningSums_0
		
		On Error Resume Next
	
	
		CalculateExpressions_0 = ""
	End Function
	
		
	' This function will calculate the running sums and expressions for the Detail section
	Function CalculateExpressions_Detail(CurrentNode, GroupNodes)
		PrepExpressions CurrentNode, GroupNodes
		
		
		On Error Resume Next
	
	
		CalculateExpressions_Detail = ""
	End Function
	
		
	' This function will calculate the running sums and expressions for the Global section
	Function CalculateExpressions_Global(CurrentNode, GroupNodes)
		PrepExpressions CurrentNode, GroupNodes
		
		
		On Error Resume Next
	

		' [Text13] = Now()
		gExpr_1 = Empty
		gExpr_1 = StaticNow()

		' [Text14] = "Page " & [Page] & " of " & [Pages]
		gExpr_2 = Empty
		gExpr_2 = "Page " & Page() & " of " & Pages()
	
		CalculateExpressions_Global = ""
	End Function
	

	' ********************************************************************************** 
	' **  Functions dynamically generated to be used for sorting and grouping
	' ********************************************************************************** 
	


	' ********************************************************************************** 
	' **  Code staticly copied for expressions to use    
	' ********************************************************************************** 
	
	'variable declaration
	Dim objCurrNode
	Dim objCurrNodeT
	Dim cGroupCount
	Dim objGroupNodes

	Set objGroupNodes = Nothing
	Set objCurrNode = Nothing
	cGroupCount = 0
	
	Function PrepExpressions(CurrentNode, GroupNodes)		
		CacheCurrentNode CurrentNode
		CacheGroupNodes GroupNodes
		PrepExpressions = ""
	End Function
	
	Function CacheCurrentNode(objNodeList)		
		Set objCurrNode = objNodeList.item(0)
		CacheCurrentNode = ""
	End Function
	
	Function CacheGroupNodes(objNodeList)
		Set objGroupNodes = objNodeList
		cGroupCount = objGroupNodes.length
		CacheGroupNodes = ""
	End Function

	Function GroupValue_quarter(strValue)
		GroupValue_quarter = Left(strValue, 4) & DatePart("q", BuildDateFromStr(strValue, False))
	End Function
	
	Function GroupValue_week(strValue)
		GroupValue_week = Left(strValue, 4) & DatePart("ww", BuildDateFromStr(strValue, False))
	End Function
	
	Function GroupValue_interval(nValue, nInterval)
		GroupValue_interval = Int(nValue / nInterval)
	End Function

	Function Page()
		Page = 1
	End Function
	
	Function Pages()
		Pages = 1
	End Function

	Function ToString(varValue)
		On Error Resume Next
		ToString = ""
		ToString = CStr(varValue)
	End Function

	Function ToNumber(varValue)
		On Error Resume Next
		ToNumber = 0
		ToNumber = CDbl(varValue)
	End Function
	
	Function FormatFromXSL(strRef, strFormat, iNumDecimals, LCID, nType)
		FormatFromXSL = ToString(Format(GetValue(strRef, nType), strFormat, iNumDecimals, LCID, nType))
	End Function

	Function Format(varValue, strFormat, iNumDecimals, LCID, nType)
		Dim FormatTemp
		Dim strTemp
										
		If IsDate(varValue) Then
			Select Case strFormat
				Case "General Date"
					FormatTemp = FormatDateTime(varValue, vbGeneralDate)
				Case "Long Date"
					FormatTemp = FormatDateTime(varValue, vbLongDate)
				Case "Medium Date"
					If GetLocale = 1054 Then ' Special case for thai year
						FormatTemp = Day(varValue) & "-" & MonthName(Month(varValue), True) & "-" & Right(FormatDateTime(varValue, vbShortDate), 2)
					Else
						FormatTemp = Day(varValue) & "-" & MonthName(Month(varValue), True) & "-" & Mid(Year(varValue), 3, 2)
					End If
				Case "Short Date"
					FormatTemp = FormatDateTime(varValue, vbShortDate)
				Case "Long Time"
					FormatTemp = FormatDateTime(varValue, vbLongTime)							
				Case "Medium Time"
					strTemp = FormatDateTime(varValue, vbLongTime)
					If (IsNumeric(Mid(strTemp, 2, 1))) Then
						FormatTemp = Mid(strTemp,1,5) & Mid(strTemp, 9)
					Else
						FormatTemp = Mid(strTemp,1,4) & Mid(strTemp, 9)
					End If
				Case "Short Time"
					FormatTemp = FormatDateTime(varValue, vbShortTime)
				Case Else
					Select Case LCase(strFormat)
						Case "yyyy", "q", "m", "y", "d", "w", "ww", "h", "n", "s"
							FormatTemp = DatePart(LCase(strFormat), varValue)
						Case Else
							' This does not currently support custom formats such as dd-mmm-yyyy										
							FormatTemp = FormatDateTime(varValue, vbGeneralDate)
					End Select
			End Select
		ElseIf IsNumeric(varValue) Then
			Select Case strFormat
				Case "General Number"
					FormatTemp = varValue
				Case "Currency"
					FormatTemp = FormatCurrencyPerLocale(varValue, iNumDecimals, LCID)
				Case "Euro"
					' This does not really support the Euro format.
					FormatTemp = FormatCurrencyPerLocale(varValue, iNumDecimals, LCID)
				Case "Fixed"
					If IsNumeric(iNumDecimals) Then
						FormatTemp = FormatNumber(varValue, iNumDecimals, vbTrue, vbUseDefault, vbFalse)
					Else
						FormatTemp = FormatNumber(varValue, 2, vbTrue, vbUseDefault, vbFalse)
					End If
				Case "Standard"
					If IsNumeric(iNumDecimals) Then
						FormatTemp = FormatNumber(varValue, iNumDecimals, vbUseDefault, vbUseDefault, vbTrue)
					Else
						FormatTemp = FormatNumber(varValue, 2, vbUseDefault, vbUseDefault, vbTrue)
					End If
				Case "Percent"
					If IsNumeric(iNumDecimals) Then
						FormatTemp = FormatPercent(varValue, iNumDecimals)
					Else
						FormatTemp = FormatPercent(varValue)
					End If
				Case "Scientific"
					Dim nExp
					Dim nValue
					If (varValue = 0)  Then
						nExp = 0
					Else
				      		nExp = Int(Log(Abs(varValue)) / Log(10))
					End If
					nValue = Round(CDbl(varValue)/(10^CDbl(nExp)), 2)
					If (Sgn(nExp) < 0) Then
						FormatTemp = FormatNumber(nValue, 2, vbTrue, vbFalse, vbFalse) & "E" & nExp
					Else
						FormatTemp = FormatNumber(nValue, 2, vbTrue, vbFalse, vbFalse) & "E+" & nExp
					End If
				Case "True/False"
					If (CBool(varValue)) Then
						FormatTemp = "True"
					Else
						FormatTemp = "False"
					End If
				Case "Yes/No"
					If (CBool(varValue)) Then
						FormatTemp = "Yes"
					Else
						FormatTemp = "No"
					End If 
				Case "On/Off"
					If (CBool(varValue)) Then
						FormatTemp = "On"
					Else
						FormatTemp = "Off"
					End If 
				Case Else 	' This is a custom format				
					If nType = 6 Then ' This is a currency
						FormatTemp = FormatCurrencyPerLocale(varValue, iNumDecimals, LCID) 
					End If
			End Select
		End If

		If IsEmpty(FormatTemp) Then								
			FormatTemp = varValue
		End If

		If FHasNoContent(FormatTemp) Then
			Format = " "
		Else
			Format = FormatTemp
		End If
						
	End Function

	Function 	FormatCurrencyPerLocale(varValue, iNumDecimals, LCID)
		Dim CurrentLCID
		If LCID >< "" Then	CurrentLCID = SetLocale(LCID)
		If IsNumeric(iNumDecimals) Then
			FormatCurrencyPerLocale = FormatCurrency(varValue, iNumDecimals)
		Else
			FormatCurrencyPerLocale = FormatCurrency(varValue)
		End If
		If Not IsEmpty(CurrentLCID) Then SetLocale CurrentLCID 
	End Function
	
	Function FHasNoContent(objValue)
		FHasNoContent = True
		
		If IsNull(objValue) Then Exit Function
		If IsEmpty(objValue) Then Exit Function
		If Not IsObject(objValue) Then 
			If objValue = "" Then Exit Function
		Else
			If objValue Is Nothing Then Exit Function
		End if

		FHasNoContent = False
	End Function

	Function IIf(fCond, varTrue, varFalse)
		If fCond Then
			IIf = varTrue
		Else
			IIf = varFalse
		End If
	End Function

	Function Nz(varValue, varReplace)
		If FHasNoContent(varValue) Then
			Nz = varReplace
		Else
			Nz = varValue
		End If
	End Function

	Function Sum(strExpr)
		Dim nSum, i

		nSum = 0
		Set objCurrNodeT = objCurrNode

		For i = 0 To cGroupCount - 1
			Set objCurrNode = objGroupNodes.item(i)	
			nSum = nSum + ToNumber(Eval(strExpr))
		Next
				
		Set objCurrNode = objCurrNodeT
		Sum = nSum
	End Function
	
	Function Count(strExpr)
		Dim nCount, i
		
		If strExpr = "*" Then
			Count = cGroupCount
			Exit Function
		End If
		
		Set objCurrNodeT = objCurrNode
		nCount = 0
		For i = 0 To cGroupCount - 1
			Set objCurrNode = objGroupNodes.item(i)	
			If Not FHasNoContent(Eval(strExpr)) Then
				nCount = nCount + 1
			End If	
		Next

		Set objCurrNode = objCurrNodeT
		Count = nCount
	End Function
		
	Function Avg(strExpr)
		Dim nSum
		Dim nCount
		nSum = Sum(strExpr)
		nCount = Count(strExpr)
		If nCount > 0 Then
			Avg = nSum / nCount
		Else
			Avg = nSum
		End If
	End Function

	Function Min(strExpr)
		Dim varMin, i
		Dim varTemp
		
		Set objCurrNodeT = objCurrNode

		For i = 0 To cGroupCount - 1
			Set objCurrNode = objGroupNodes.item(i)	
			varTemp = Eval(strExpr)
			If IsEmpty(varMin) Or (varTemp < varMin) Then
				varMin = varTemp
			End If	
		Next

		Set objCurrNode = objCurrNodeT
		Min = varMin
	End Function
	
	Function Max(strExpr)
		Dim varMax, i
		Dim varTemp
	
		varMax = Eval(strExpr)
		Set objCurrNodeT = objCurrNode
		
		For i = 0 To cGroupCount - 1
			Set objCurrNode = objGroupNodes.item(i)	
			varTemp = Eval(strExpr)
			If IsEmpty(varMax) Or (varTemp > varMax) Then
				varMax = varTemp
			End If	
		Next
		
		Set objCurrNode = objCurrNodeT
		Max = varMax
	End Function
	
	Function GetValue(strRef, nType)
		' Set Null as the default return value
		GetValue = Null

		' Return Null if anything goes wrong
		On Error Resume Next
	
		Dim objNode
		Set objNode = objCurrNode.selectSingleNode(strRef)
		If (objNode Is Nothing) Or IsNull(objNode) Or IsEmpty(objNode) Or Not IsObject(objNode) Then
			Exit Function
		End If

		Dim CurrentLCID
		CurrentLCID = SetLocale(1033)
		
		Select Case nType
			Case 2		 	' adSmallInt
				GetValue = CLng(objNode.text)

			Case 3 		' adInteger
				GetValue = CLng(objNode.text)

			Case 20		' adBigInt
				GetValue = CLng(objNode.text)

			Case 17		' adUnsignedTinyInt
				GetValue = CLng(objNode.text)

			Case 18		' adUnsignedSmallInt
				GetValue = CLng(objNode.text)

			Case 19		' adUnsignedInt
				GetValue = CLng(objNode.text)

			Case 21		' adUnsignedBigInt
				GetValue = CLng(objNode.text)

			Case 4		' adSingle
				GetValue = CDbl(objNode.text)

			Case 5		' adDouble
				GetValue = CDbl(objNode.text)

			Case 6		' adCurrency
				GetValue = CCur(objNode.text)

			Case 14		' adDecimal
				GetValue = CDbl(objNode.text)

			Case 131		' adNumeric
				GetValue = CDbl(objNode.text)

			Case 139		' adVarNumeric
				GetValue = CDbl(objNode.text)

			Case 11		' adBoolean
				GetValue = CBool(objNode.text)

			Case 7 		' adDate
				GetValue = BuildDateFromStr(objNode.text, True)

			Case 133		' adDBDate
				GetValue = BuildDateFromStr(objNode.text, True)

			Case 134		' adDBTime
				GetValue = BuildDateFromStr(objNode.text, True)

			Case 135		' adDBTimeStamp
				GetValue = BuildDateFromStr(objNode.text, True)

			Case 8		' adBSTR
				GetValue = objNode.text				

			Case 120		' adChar
				GetValue = objNode.text				

			Case 200		' adVarChar
				GetValue = objNode.text				

			Case 201		' adLongVarChar
				GetValue = objNode.text				

			Case 130		' adWChar:
				GetValue = objNode.text				

			Case 202		' adVarWChar
				GetValue = objNode.text				

			Case 203		' adLongVarWChar	
				GetValue = objNode.text		

			Case -7 		' Special value used to get just the date.
				GetValue = BuildDateFromStr(objNode.text, False)				

			Case Else
				GetValue = objNode.text				
		End Select

		SetLocale CurrentLCID
	End Function

	Dim gStaticDate
	Function StaticDate()
		If IsEmpty(gStaticDate) Then gStaticDate = GetValue("/*/@generated", -7)
		StaticDate = gStaticDate
	End Function

	Dim gStaticNow
	Function StaticNow()
		If IsEmpty(gStaticNow) Then gStaticNow = GetValue("/*/@generated", 7)
		StaticNow = gStaticNow
	End Function
	
	Function BuildDateFromStr(strDate, fIncludeTime)
		Dim CurrentLCID
		CurrentLCID = SetLocale(1033)
		' This requires that the Locale be set to en-us (1033).
		BuildDateFromStr = CDate(Left(strDate,10))

		If (fIncludeTime) Then
			BuildDateFromStr = BuildDateFromStr  + CDate(Right(strDate,8))
		End If
		SetLocale CurrentLCID
	End Function

	Function ArrayItem(arr, index)
		If index > UBound(arr) Then
			ArrayItem = ""
		Else
			ArrayItem = arr(index)
		End If
	End Function

	Function HyperlinkPartFromNodeList(nodelist, nPart)
		If nodelist.length = 0 Then
			HyperlinkPartFromNodeList = ""
		Else
			HyperlinkPartFromNodeList = HyperlinkPartFromString(nodelist.item(0).text, nPart)
		End If
	End Function
	
	Function HyperlinkPart(strRef, nPart)
		HyperlinkPart = HyperlinkPartFromString(GetValue(strRef, 200), nPart)
	End Function
	
	Function HyperlinkPartFromString(strHyperlink, nPart)
		Dim arrParts
		Dim strHyperlinkPart
		Dim strAddress, strSubAddress
		
		arrParts = Split(strHyperlink, "#")

		Select Case nPart
			Case 0 		' acDisplayedValue
				strHyperlinkPart = ArrayItem(arrParts, 0)
				If strHyperlinkPart = "" Then
					strAddress = ArrayItem(arrParts, 1)
					strSubAddress = ArrayItem(arrParts, 2)

					If strAddress = "" and strSubAddress = "" Then
						strHyperlinkPart = ""
					ElseIf strSubAddress = "" Then
						strHyperlinkPart = strAddress
					ElseIf strAddress = "" Then
						strHyperlinkPart = strSubAddress
					Else
						strHyperlinkPart = strAddress & " - " & strSubAddress
					End If
				End If
			Case 1 		' acDisplayText
				strHyperlinkPart = ArrayItem(arrParts, 0)
			Case 2 		' acAddress
				strHyperlinkPart = ArrayItem(arrParts, 1)
			Case 3 		' acSubAddress
				strHyperlinkPart = ArrayItem(arrParts, 2)
			Case 4 		' acScreenTip
				strHyperlinkPart = ArrayItem(arrParts, 3)
			Case 5 		' acFullAddress
				strAddress = ArrayItem(arrParts, 1)
				strSubAddress = ArrayItem(arrParts, 2)
				
				If strAddress = "" and strSubAddress = "" Then
					strHyperlinkPart = "#"
				ElseIf strSubAddress = "" Then
					strHyperlinkPart = strAddress
				Else
					strHyperlinkPart = strAddress & "#" & strSubAddress
				End If
		End Select
		HyperlinkPartFromString = strHyperlinkPart
	End Function
			]]></msxsl:script>
</xsl:stylesheet>
